/*
 * $Id: _exit.c,v 1.5 2002/11/25 03:50:34 reuther Exp $
 */

/*****************************************************************************
 * liboskit_support/src/_exit.c                                              *
 * OSKit support functions                                                   *
 *****************************************************************************/

/* L4 includes */
#include <l4/sys/types.h>
#include <l4/sys/ipc.h>
#include <l4/sys/syscalls.h>
#include <l4/sys/kdebug.h>

/* OSKit includes */
#include <stdio.h>

#include <flux/machine/pc/reset.h>

/*****************************************************************************
 * exit                                                                      *
 *****************************************************************************/
void _exit(int fd)
{
  char c;

  if(fd){
    printf("\nExiting with rc=%d\n"
           "Return reboots, \"k\" enters L4 kernel debugger...\n",
           fd);
    c = getchar();

    if (c == 'k' || c == 'K') 
      enter_kdebug("before reboot");

    pc_reset();
  } else {
    printf("\nExit, rc=%d\nFalling asleep.", fd);
    
    while(1){
      l4_msgdope_t result;
      l4_umword_t dummy;
      
      l4_i386_ipc_receive(L4_NIL_ID, L4_IPC_SHORT_MSG, &dummy, &dummy,
                 L4_IPC_NEVER, &result);
   }
 }
}

